<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2008 osCommerce

  Released under the GNU General Public License
*/

  class paypal_hss {
    var $code, $title, $description, $enabled;

// class constructor
    function paypal_hss() {
      global $order;

      $this->code = 'paypal_hss';
      $this->title = MODULE_PAYMENT_PAYPAL_HSS_TEXT_TITLE;
      $this->public_title = MODULE_PAYMENT_PAYPAL_HSS_TEXT_PUBLIC_TITLE;
      $this->description = MODULE_PAYMENT_PAYPAL_HSS_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_PAYPAL_HSS_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_PAYPAL_HSS_STATUS == 'True') ? true : false);
      $this->email_footer = MODULE_PAYMENT_PAYPAL_HSS_TEXT_EMAIL_FOOTER;
      if ((int)MODULE_PAYMENT_PAYPAL_HSS_PREPARE_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_PAYPAL_HSS_PREPARE_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYPAL_HSS_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYPAL_HSS_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->public_title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      ini_set('display_errors',true);
      ini_set('error_reporting', E_ALL & ~E_WARNING & ~E_NOTICE);
      $_SESSION['btnParams'] = $this->getButtonParams();
      return false;
    }
    function getButtonParams() {
        global $customer_id, $order, $sendto, $currency, $cart_PayPal_Standard_ID, $shipping;
        $parameters = array('cmd' => '_hosted-payment',
                          'item_name' => STORE_NAME,
//                          'shipping' => $this->format_raw($order->info['shipping_cost']),
//                          'tax' => $this->format_raw($order->info['tax']),
                          'business' => MODULE_PAYMENT_PAYPAL_HSS_ID,
                          'subtotal' => $this->format_raw($order->info['total']),
                          'currency_code' => $currency,
                          'invoice' => substr($cart_PayPal_Standard_ID, strpos($cart_PayPal_Standard_ID, '-')+1),
                          'custom' => $customer_id,
                          'no_note' => '1',
                          'notify_url' => tep_href_link('ext/modules/payment/paypal/standard_ipn.php', '', 'SSL', false, false),
                          'ipnNotificationUrl' => tep_href_link('ext/modules/payment/paypal/standard_ipn.php', '', 'SSL', false, false),                                                                                  
                          'return' => tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL'),
                          'cancel_return' => tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'),
                          'bn' => 'OSCOMMERCE-HSS',
        				//  'template' => 'Template' . MODULE_PAYMENT_PAYPAL_HSS_PAGE_STYLE,
                          'paymentaction' =>  'sale');
                       //  'paymentaction' => ((MODULE_PAYMENT_PAYPAL_HSS_TRANSACTION_METHOD == 'Sale') ? 'sale' : 'authorization')
        
      if (is_numeric($sendto) && ($sendto > 0)) {
        $parameters['address_override'] = '1';
        $parameters['first_name'] = $order->delivery['firstname'];
        $parameters['last_name'] = $order->delivery['lastname'];
        $parameters['address1'] = $order->delivery['street_address'];
        $parameters['city'] = $order->delivery['city'];
        $parameters['state'] = tep_get_zone_code($order->delivery['country']['id'], $order->delivery['zone_id'], $order->delivery['state']);
        $parameters['zip'] = $order->delivery['postcode'];
        $parameters['country'] = $order->delivery['country']['iso_code_2'];
      } else {
        $parameters['no_shipping'] = '1';
        $parameters['first_name'] = $order->billing['firstname'];
        $parameters['last_name'] = $order->billing['lastname'];
        $parameters['address1'] = $order->billing['street_address'];
        $parameters['city'] = $order->billing['city'];
        $parameters['state'] = tep_get_zone_code($order->billing['country']['id'], $order->billing['zone_id'], $order->billing['state']);
        $parameters['zip'] = $order->billing['postcode'];
        $parameters['country'] = $order->billing['country']['iso_code_2'];
      }
                    //*/
      if (tep_not_null(MODULE_PAYMENT_PAYPAL_HSS_PAGE_STYLE)) {
        $parameters['page_style'] = 'Template' . MODULE_PAYMENT_PAYPAL_HSS_PAGE_STYLE;
      }
      
      if (MODULE_PAYMENT_PAYPAL_HSS_EWP_STATUS == 'True') {
        $parameters['cert_id'] = MODULE_PAYMENT_PAYPAL_HSS_EWP_CERT_ID;
      }
      
      return $parameters;
    }

    function before_process() {
      return false;
    }

    function after_process_redirection() {
      
    }
    function after_process() {
      if (MODULE_PAYMENT_PAYPAL_HSS_GATEWAY_SERVER == 'Live') {
        $this->form_action_url = 'https://securepayments.paypal.com/acquiringweb';
      } else {
        $this->form_action_url = 'https://securepayments.sandbox.paypal.com/acquiringweb';
      }
      $parameters = $_SESSION['btnParams'];
      if(!isset($parameters['invoice']) || (int)$parameters['invoice']<1) {
        global $insert_id;
        $parameters['invoice'] = $insert_id;
      }
      if(is_object($cart) && method_exists($cart, 'reset')) {
        $cart->reset(true);
      }

      // order status di default
      // ricavo l'order id 
      $status_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name like '%Transaction under revision%' ");
      $status = tep_db_fetch_array($status_query);
      
      
           $sql_data_array = array('orders_id' => $insert_id,
                                  'orders_status_id' => $status['orders_status_id'],
                                  'date_added' => 'now()',
                                  'customer_notified' => '0',
                                  'comments' => '');
          
          tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);


          tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $status['orders_status_id']  . "', last_modified = now() where orders_id = '" . $insert_id . "'");
      
      
      
// unregister session variables used during checkout
      tep_session_unregister('sendto');
      tep_session_unregister('billto');
      tep_session_unregister('shipping');
      tep_session_unregister('payment');
      tep_session_unregister('comments');
  
      unset($_SESSION['btnParams']);
      ?><html>
      <head>
      </head>
      <body onload="document.getElementById('submitForm').submit();">
      <form id="submitForm" action="<?php echo $this->form_action_url;?>" method="POST">
      <?php
      foreach($parameters as $k=>$v) {
      echo '<input type="hidden" name="'.$k.'" value="'.$v.'" />'."\n";
      
      }
      ?>
      </form>
      </body>
      </html>
      <?php
      exit;
      //*/
      return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYPAL_HSS_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {

    	$languages = tep_get_languages();
	/*	print_r($_SESSION);
		print_r($languages);
		exit;	
    	*/
      $check_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name like  '%Transaction under revision%' limit 1");

	include(DIR_FS_CATALOG_LANGUAGES .  $_SESSION['language'] . '/modules/payment/paypal_hss.php'); 
	
	
      if (tep_db_num_rows($check_query) < 1) { // se gli status non sono stati definiti
        $status_query = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
        $status = tep_db_fetch_array($status_query);

        $status_id = $status['status_id']+1;

 
        foreach ($languages as $lang) {        	      	
        if ($lang['code'] == 'it')
          tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $lang['id'] . "', 'Transazione accettata')");
          else 
       	  tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $lang['id'] . "', 'Transaction accepted')");
          	  
       	  
        if ($lang['code'] == 'it')
          tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id,  language_id, orders_status_name) values ('" . ($status_id + 1) . "', '" . $lang['id'] . "', 'Transazione sotto revisione')");
        else 
       	  tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id,  language_id, orders_status_name) values ('" . ($status_id + 1) . "', '" . $lang['id'] . "', 'Transaction under revision')");

       	  
        if ($lang['code'] == 'it')
          tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id,  language_id, orders_status_name) values ('" . ($status_id + 2) . "', '" . $lang['id'] . "', 'Transazione rifiutata')");
        else 
       	  tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id,  language_id, orders_status_name) values ('" . ($status_id + 2) . "', '" . $lang['id'] . "', 'Transaction rejected')");
        }

        $flags_query = tep_db_query("describe " . TABLE_ORDERS_STATUS . " public_flag");
        if (tep_db_num_rows($flags_query) == 1) {
          tep_db_query("update " . TABLE_ORDERS_STATUS . " set public_flag = 1 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
        }
      } else {
        $check = tep_db_fetch_array($check_query);

        $status_id = $check['orders_status_id'];
      }
      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values 
            ('" . MODULE_PAYMENT_PAYPAL_HSS_DEFINED_STATUS . "', 'MODULE_PAYMENT_PAYPAL_HSS_STATUS', 'False', '" . MODULE_PAYMENT_PAYPAL_HSS_DEFINED_STATUS_DESC . "', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
            ('" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_ID. "', 'MODULE_PAYMENT_PAYPAL_HSS_ID', '', '" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_ID_DESC. "', '6', '4', now())");

      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
            ('" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_SORT_ORDER. "', 'MODULE_PAYMENT_PAYPAL_HSS_SORT_ORDER', '0', '" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_SORT_ORDER_DESC. "', '6', '0', now())");

      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values 
            ('" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_ZONE. "', 'MODULE_PAYMENT_PAYPAL_HSS_ZONE', '0', '" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_ZONE_DESC. "', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
  
/*
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_PREPAREORDERSTATUSID', 'MODULE_PAYMENT_PAYPAL_HSS_PREPARE_ORDER_STATUS_ID', '" . $status_id . "', 'Set the status of prepared orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYPAL_HSS_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
*/   

      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values 
            ('" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_GATEWAY_SERVER. "', 'MODULE_PAYMENT_PAYPAL_HSS_GATEWAY_SERVER', 'Live', '" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_GATEWAY_SERVER_DESC. "', '6', '6', 'tep_cfg_select_option(array(\'Live\', \'Sandbox\'), ', now())");
 
 /*     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_TRANSACTION_METHOD', 'MODULE_PAYMENT_PAYPAL_HSS_TRANSACTION_METHOD', 'Sale', 'The processing method to use for each transaction.', '6', '0', 'tep_cfg_select_option(array(\'Authorization\', \'Sale\'), ', now())");
  */    
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order,  set_function, date_added) values 
            ('" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_PAGE_STYLE. "', 'MODULE_PAYMENT_PAYPAL_HSS_PAGE_STYLE', 'A', '" .MODULE_PAYMENT_PAYPAL_HSS_DEFINED_PAGE_STYLE_DESC. "', '6', '4', 'tep_cfg_select_option(array(\'A\', \'B\', \'C\'), ', now())");
 /*     tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_DEBUG_EMAIL', 'MODULE_PAYMENT_PAYPAL_HSS_DEBUG_EMAIL', '', 'All parameters of an Invalid IPN notification will be sent to this email address if one is entered.', '6', '4', now())");
  
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_EWP_STATUS', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_STATUS', 'False', 'Do you want to enable Encrypted Web Payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_EWP_PRIVATE_KEY', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_PRIVATE_KEY', '', 'The location of your Private Key to use for signing the data. (*.pem)', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_EWP_PUBLIC_KEY', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_PUBLIC_KEY', '', 'The location of your Public Certificate to use for signing the data. (*.pem)', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_EWP_PAYMENT_PAYPAL_KEY', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_PAYMENT_PAYPAL_KEY', '', 'The location of the PayPal Public Certificate for encrypting the data.', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_EWP_CERT_ID', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_CERT_ID', '', 'The Certificate ID to use from your PayPal Encrypted Payment Settings Profile.', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_EWP_WORKING_DIRECTORY', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_WORKING_DIRECTORY', '', 'The working directory to use for temporary files. (trailing slash needed)', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
            ('MODULE_PAYMENT_PAYPAL_HSS_DEFINED_EWP_OPENSSL', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_OPENSSL', '/usr/bin/openssl', 'The location of the openssl binary file.', '6', '4', now())");
  */
  }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
     // return array('MODULE_PAYMENT_PAYPAL_HSS_STATUS', 'MODULE_PAYMENT_PAYPAL_HSS_ID', 'MODULE_PAYMENT_PAYPAL_HSS_ZONE', 'MODULE_PAYMENT_PAYPAL_HSS_PREPARE_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYPAL_HSS_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYPAL_HSS_GATEWAY_SERVER', 'MODULE_PAYMENT_PAYPAL_HSS_TRANSACTION_METHOD', 'MODULE_PAYMENT_PAYPAL_HSS_PAGE_STYLE', 'MODULE_PAYMENT_PAYPAL_HSS_DEBUG_EMAIL', 'MODULE_PAYMENT_PAYPAL_HSS_SORT_ORDER', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_STATUS', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_PRIVATE_KEY', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_PUBLIC_KEY', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_PAYMENT_PAYPAL_KEY', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_CERT_ID', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_WORKING_DIRECTORY', 'MODULE_PAYMENT_PAYPAL_HSS_EWP_OPENSSL');
    return array('MODULE_PAYMENT_PAYPAL_HSS_STATUS', 'MODULE_PAYMENT_PAYPAL_HSS_ID', 'MODULE_PAYMENT_PAYPAL_HSS_ZONE',  'MODULE_PAYMENT_PAYPAL_HSS_GATEWAY_SERVER', 'MODULE_PAYMENT_PAYPAL_HSS_PAGE_STYLE', 'MODULE_PAYMENT_PAYPAL_HSS_SORT_ORDER' );
 }

// format prices without currency formatting
    function format_raw($number, $currency_code = '', $currency_value = '') {
      global $currencies, $currency;

      if (empty($currency_code) || !$this->is_set($currency_code)) {
        $currency_code = $currency;
      }

      if (empty($currency_value) || !is_numeric($currency_value)) {
        $currency_value = $currencies->currencies[$currency_code]['value'];
      }

      return number_format(tep_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
    }
  }
?>
